// SniffUSBDlg.cpp : implementation file
//

#include "StdAfx.h"
#include "SniffUSB.h"
#include "SniffUSBDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSniffUSBDlg dialog

CSniffUSBDlg::CSniffUSBDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSniffUSBDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSniffUSBDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_sFilterName.LoadString(IDS_FILTERNAME);
    m_sFilterName.MakeLower();
    m_sLowerFilters.LoadString(IDS_LOWERFILTERS);

    m_bIsWin2K = 0 == (GetVersion() & 0x80000000);
    m_sFilterName.LoadString(m_bIsWin2K ? IDS_FILTERNAME2K : IDS_FILTERNAME9X);
    m_sFilterName.MakeLower();
    m_sLowerFilters.LoadString(IDS_LOWERFILTERS);
    m_dwUsbSnoopSize = 0;
    m_pUsbSnoop = NULL;
    m_szWinDir = _T("");
}

void CSniffUSBDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSniffUSBDlg)
	DDX_Control(pDX, IDC_USBDEVS, m_cDevs);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSniffUSBDlg, CDialog)
	//{{AFX_MSG_MAP(CSniffUSBDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_REFRESH, OnRefresh)
	ON_BN_CLICKED(IDC_INSTALL, OnInstall)
	ON_BN_CLICKED(IDC_UNINSTALL, OnUninstall)
	ON_NOTIFY(NM_RCLICK, IDC_USBDEVS, OnRclickUsbdevs)
	ON_COMMAND(ID_SNOOPUSB_INSTALL, OnSnoopusbInstall)
	ON_COMMAND(ID_SNOOPUSB_UNINSTALL, OnSnoopusbUninstall)
	ON_BN_CLICKED(IDC_REPLUG, OnReplug)
	ON_COMMAND(ID_SNOOPUSB_REPLUG, OnSnoopusbReplug)
	ON_BN_CLICKED(IDC_FILTERINSTALL, OnFilterInstall)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSniffUSBDlg message handlers

BOOL CSniffUSBDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
    // we want report style and more...
    m_cDevs.ModifyStyle(LVS_TYPEMASK, LVS_AUTOARRANGE | LVS_SORTASCENDING | 
        LVS_REPORT | LVS_SINGLESEL | LVS_SHOWSELALWAYS);
    m_cDevs.SetExtendedStyle(LVS_EX_FULLROWSELECT);

    // setup the columns
    CString sHeading;
    sHeading.LoadString(IDS_COL_VIDPID);
    m_cDevs.InsertColumn(0, sHeading);
    m_nCX0 = 5*m_cDevs.GetStringWidth(sHeading)/4;

    sHeading.LoadString(IDS_COL_FILTERINSTALLED);
    m_cDevs.InsertColumn(1, sHeading, LVCFMT_CENTER);
    m_nCX1 = 5*m_cDevs.GetStringWidth(sHeading)/4;

    sHeading.LoadString(IDS_COL_DESCRIPTION);
    m_cDevs.InsertColumn(2, sHeading);
    m_nCX2 = 5*m_cDevs.GetStringWidth(sHeading)/4;

    m_cDevs.SetColumnWidth(0, m_nCX0);
    m_cDevs.SetColumnWidth(1, m_nCX1);
    m_cDevs.SetColumnWidth(2, m_nCX2);

    // load DXSniffer dll from resources...
    HRSRC hRsrc = FindResource(AfxGetResourceHandle(), "BIN_DRIVER", "SNOP");
    if(NULL == hRsrc)
    {
        TRACE("ERROR: Couldn't locate UsbSnoop.sys driver in resources!\n");
    }

    m_dwUsbSnoopSize = SizeofResource(AfxGetResourceHandle(), hRsrc);
    if(0 == m_dwUsbSnoopSize)
    {
        TRACE("ERROR: Size of UsbSnoop image is 0!\n");
    }

    HGLOBAL hUsbSnoop = LoadResource(AfxGetResourceHandle(), hRsrc);
    if(NULL == hUsbSnoop)
    {
        TRACE("ERROR: Couldn't load UsbSnoop.sys driver from resources!\n");
    }

    m_pUsbSnoop = LockResource(hUsbSnoop);
    if(NULL == m_pUsbSnoop)
    {
        TRACE("ERROR: Couldn't lock UsbSnoop.sys driver from resources!\n");
    }

    GetWindowsDirectory(m_szWinDir.GetBuffer(MAX_PATH), MAX_PATH);
    m_szWinDir.ReleaseBuffer();
    if(m_szWinDir.IsEmpty())
    {
        TRACE("ERROR: Couldn't locate windows directory!\n");
    }
    m_szWinDir += "\\System32\\Drivers\\UsbSnoop.sys";

    // fill it up, please
    OnRefresh();

    m_cToolTips.Create(this);
	m_cToolTips.SetMaxTipWidth(300);
	m_cToolTips.AddTool(GetDlgItem(IDCANCEL), IDS_TT_CLOSE);
	m_cToolTips.AddTool(GetDlgItem(IDC_UNINSTALL), IDS_TT_UNINSTALL);
	m_cToolTips.AddTool(GetDlgItem(IDC_INSTALL), IDS_TT_INSTALL);
	m_cToolTips.AddTool(GetDlgItem(IDC_REFRESH), IDS_TT_REFRESH);
	m_cToolTips.AddTool(GetDlgItem(IDC_REPLUG), IDS_TT_REPLUG);
	m_cToolTips.AddTool(GetDlgItem(IDC_FILTERINSTALL), IDS_TT_UNPACK_SYS);
	m_cToolTips.Activate(TRUE);
    
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSniffUSBDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSniffUSBDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSniffUSBDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSniffUSBDlg::OnRefresh() 
{
    UINT nSelCount = m_cDevs.GetSelectedCount();
    int nSelection = -1;
    CString sSelection;
    if(1 == nSelCount)
    {
        nSelection = m_cDevs.GetNextItem(-1, LVNI_SELECTED);
        sSelection = m_cDevs.GetItemText(nSelection, 0);
    }
    m_cDevs.DeleteAllItems();
    int cx0 = m_nCX0;
    int cx1 = m_nCX1;
    int cx2 = m_nCX2;
    
	CSetupDIMgr mgr;
	while(mgr.Enum())
	{
        CString sName;
        if(mgr.HardwareID(sName))
        {
            //TRACE("Enumerated >%s<\n", sName);
            CString sFilter;
            sFilter.LoadString(mgr.IsLowerFilterPresent(m_sFilterName) ? IDS_INSTALLED : IDS_NOTINSTALLED);
            CString sDescription;
            mgr.DeviceName(sDescription);
            int nIndex = m_cDevs.InsertItem(-1, sName);
            m_cDevs.SetItemText(nIndex, 1, sFilter);
            m_cDevs.SetItemText(nIndex, 2, sDescription);
            cx0 = max(cx0, 5*m_cDevs.GetStringWidth(sName)/4);
            cx1 = max(cx1, 5*m_cDevs.GetStringWidth(sFilter)/4);
            cx2 = max(cx2, 5*m_cDevs.GetStringWidth(sDescription)/4);
        }
    }

    m_cDevs.SetColumnWidth(0, cx0);
    m_cDevs.SetColumnWidth(1, cx1);
    m_cDevs.SetColumnWidth(2, cx2);

    if(-1 != nSelection)
    {
        LVFINDINFO fi;
        ZeroMemory(&fi, sizeof(fi));
        fi.flags = LVFI_STRING;
        fi.psz = sSelection;
        nSelection = m_cDevs.FindItem(&fi);
        m_cDevs.SetItemState(nSelection, LVIS_SELECTED, LVIS_SELECTED);
    }
}

BOOL CSniffUSBDlg::SnoopUSBSysPresent(void)
{
	CFileFind ff;
	return ff.FindFile(m_szWinDir);
}

BOOL CSniffUSBDlg::GetSelectedHardwareID(CString& sHardwareID)
{
    UINT nSelected = m_cDevs.GetSelectedCount();
    if(0 == nSelected)
    {
        AfxMessageBox(IDS_SELECT_ITEM_FIRST);
        return FALSE;
    }

    int nIndex = m_cDevs.GetNextItem(-1, LVNI_SELECTED);
    sHardwareID = m_cDevs.GetItemText(nIndex, 0);
    return TRUE;
}

void CSniffUSBDlg::OnInstall() 
{
    CString sHardwareID;
    if(GetSelectedHardwareID(sHardwareID))
    {
        TRACE("Installing on %s\n", sHardwareID);
        CSetupDIMgr mgr;
		if(mgr.FindHardwareID(sHardwareID))
		{
			if(m_bIsWin2K)
			{
				mgr.InstallService(m_sFilterName, m_szWinDir, "USB Snoopy Filter Driver");
			}
			mgr.AddLowerFilter(m_sFilterName);
		}
        OnRefresh();
    }
}

void CSniffUSBDlg::OnUninstall() 
{
    CString sHardwareID;
    if(GetSelectedHardwareID(sHardwareID))
    {
        TRACE("Uninstalling from %s\n", sHardwareID);
        CSetupDIMgr mgr;
		if(mgr.FindHardwareID(sHardwareID))
		{
			mgr.RemoveLowerFilter(m_sFilterName);
		}
        OnRefresh();
    }
}

void CSniffUSBDlg::OnReplug() 
{
    CString sHardwareID;
    if(GetSelectedHardwareID(sHardwareID))
    {
        CWaitCursor waitcursor;
		CSetupDIMgr mgr(TRUE);
		if(mgr.FindHardwareID(sHardwareID))
		{
			mgr.RestartDevice();
		}
		OnRefresh();
        TRACE("Back to life..\n");
    }
}

void CSniffUSBDlg::OnRclickUsbdevs(NMHDR* pNMHDR, LRESULT* pResult) 
{
    CMenu ctx;
    ctx.LoadMenu(IDR_SNOOPUSB);
    CMenu *popup = ctx.GetSubMenu(0);
    CPoint point;
    GetCursorPos(&point);
    CPoint pt = point;
    m_cDevs.ScreenToClient(&pt);
    UINT uFlags = 0;
    int nIndex = m_cDevs.HitTest(pt, &uFlags);
    if(LVHT_ONITEM & uFlags)
    {
        m_cDevs.SetItem(nIndex, 0, LVIF_STATE, NULL, 0, LVIS_SELECTED, LVIS_SELECTED, 0);
        CString sHardwareID = m_cDevs.GetItemText(nIndex, 0);
		CSetupDIMgr mgr;
		BOOL bFilterPresent = FALSE;
		if(mgr.FindHardwareID(sHardwareID))
		{
			bFilterPresent = mgr.IsLowerFilterPresent(m_sFilterName);
		}
        if(bFilterPresent)
        {
            popup->EnableMenuItem(ID_SNOOPUSB_INSTALL, MF_BYCOMMAND | MF_GRAYED);
        }
        else
        {
            popup->EnableMenuItem(ID_SNOOPUSB_UNINSTALL, MF_BYCOMMAND | MF_GRAYED);
        }
		if(!SnoopUSBSysPresent())
		{
			popup->EnableMenuItem(ID_SNOOPUSB_INSTALL, MF_BYCOMMAND | MF_GRAYED);
		}
        popup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x, point.y, this);
    }
	
	*pResult = 0;
}

void CSniffUSBDlg::OnSnoopusbInstall() 
{
    OnInstall();	
}

void CSniffUSBDlg::OnSnoopusbUninstall() 
{
    OnUninstall();
}

void CSniffUSBDlg::OnSnoopusbReplug() 
{
    OnReplug();	
}

void CSniffUSBDlg::OnFilterInstall() 
{
    if((0 == m_dwUsbSnoopSize) || (NULL == m_pUsbSnoop))
    {
        AfxMessageBox(IDS_ERR_NOFILTERINRESOURCES);
        return;
    }

	CFileFind ff;
	if(!ff.FindFile(m_szWinDir) || (IDYES == AfxMessageBox(IDS_ASKFILTERINSTALL, MB_YESNO | MB_ICONQUESTION)))
    {
        HANDLE hFilter = CreateFile(m_szWinDir, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
        if(INVALID_HANDLE_VALUE != hFilter)
        {
            DWORD dwWritten = 0;
            if(!WriteFile(hFilter, m_pUsbSnoop, m_dwUsbSnoopSize, &dwWritten, NULL) || (dwWritten != m_dwUsbSnoopSize))
            {
                CloseHandle(hFilter);
                DeleteFile(m_szWinDir);
                AfxMessageBox(IDS_ERR_WRITEFAILED, MB_ICONSTOP);
                return;
            }
            CloseHandle(hFilter);
            AfxMessageBox(IDS_FILTERINSTALLOK, MB_ICONINFORMATION);
            return;
        }
        AfxMessageBox(IDS_ERR_CREATEFAILED, MB_ICONSTOP);
    }
}

BOOL CSniffUSBDlg::PreTranslateMessage(MSG* pMsg) 
{
	if(NULL != pMsg)
	{
		UINT message = pMsg->message;
		if ((message == WM_MOUSEMOVE || message == WM_NCMOUSEMOVE ||
			 message == WM_LBUTTONUP || message == WM_RBUTTONUP ||
			 message == WM_MBUTTONUP) &&
			(GetKeyState(VK_LBUTTON) >= 0 && GetKeyState(VK_RBUTTON) >= 0 &&
			 GetKeyState(VK_MBUTTON) >= 0))
		{
			m_cToolTips.RelayEvent(pMsg);
		}
	}
	
	return CDialog::PreTranslateMessage(pMsg);
}
